Bug 1274059 - [GSS](6.4.z) JBoss hits IllegalStateException upon reload after adding modcluster subsystem
[GSS](6.4.z) JBoss hits IllegalStateException upon reload after adding modclu...
Status: CLOSED CURRENTRELEASE
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: mod_cluster (Show other bugs)
6.4.4
Unspecified Unspecified
unspecified Severity unspecified
: CR1
: EAP 6.4.6
Assigned To: Aaron Ogburn
Michal Karm Babacek
:
Depends On:
Blocks: 1235746
  Show dependency treegraph
 
Reported: 2015-10-21 15:31 EDT by Aaron Ogburn
Modified: 2017-01-17 06:47 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-01-17 06:46:48 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Knowledge Base (Solution) 2018753 None None None 2016-01-21 19:37 EST

  None (edit)
Description Aaron Ogburn 2015-10-21 15:31:34 EDT
Description of problem:

Adding the modcluster subsystem and then reloading hits an IllegalStateException upon reload:

java.lang.IllegalStateException: JBAS018786: Multiple Deployment Unit registered processors with priority class 7170 and class org.jboss.as.modcluster.ModClusterServiceWebDependencyProcessor
at org.jboss.as.server.DeployerChainAddHandler.addDeploymentProcessor(DeployerChainAddHandler.java:63)
	at org.jboss.as.server.AbstractDeploymentChainStep$1.addDeploymentProcessor(AbstractDeploymentChainStep.java:40)
	at org.jboss.as.modcluster.ModClusterSubsystemAdd$1.execute(ModClusterSubsystemAdd.java:96)
	at org.jboss.as.server.AbstractDeploymentChainStep.execute(AbstractDeploymentChainStep.java:50)
	at org.jboss.as.controller.AbstractOperationContext.executeStep(AbstractOperationContext.java:702) [jboss-as-controller-7.5.0.Final-redhat-21.jar:7.5.0.Final-redhat-21]
	at org.jboss.as.controller.AbstractOperationContext.doCompleteStep(AbstractOperationContext.java:537) [jboss-as-controller-7.5.0.Final-redhat-21.jar:7.5.0.Final-redhat-21]
	at org.jboss.as.controller.AbstractOperationContext.completeStepInternal(AbstractOperationContext.java:338)


Version-Release number of selected component (if applicable):

EAP 6.4.4

How reproducible:

Always

Steps to Reproduce:
1. Start JBoss with default standalone.xml
2. Issue following CLI commands

[standalone@localhost:9999 /] /extension=org.jboss.as.modcluster:add
[standalone@localhost:9999 /] batch
[standalone@localhost:9999 / #] /subsystem=modcluster:add()
[standalone@localhost:9999 / #] /subsystem=modcluster/mod-cluster-config=configuration:add(connector=http,advertise="false",proxy-list="127.0.0.1:6666")
[standalone@localhost:9999 / #] run-batch
[standalone@localhost:9999 /] :reload


3. Note the error upon reload

Actual results:

JBoss fails upon reload after adding the modcluster subsystem


Expected results:

JBoss does not fail upon reload after adding the modcluster subsystem


Additional info:

EAP 6 currently adds modcluster through a runtime operation so the commands leave a ModClusterServiceWebDependencyProcessor in the DeployerChainAddHandler deployerMap, allowing for the reload failure.  Upstream wildfly modcluster uses a boottime operation, which avoids this issue, so EAP 6 should likely do the same.
Comment 1 Aaron Ogburn 2015-10-21 15:36:46 EDT
PR: https://github.com/jbossas/jboss-eap/pull/2589
Comment 2 Michael Cada 2016-01-13 10:11:06 EST
Verified with EAP 6.4.6.CP.CR2
Comment 3 Petr Penicka 2017-01-17 06:46:48 EST
Retroactively bulk-closing issues from released EAP 6.4 cumulative patches.
Comment 4 Petr Penicka 2017-01-17 06:47:53 EST
Retroactively bulk-closing issues from released EAP 6.4 cumulative patches.

Note You need to log in before you can comment on or make changes to this bug.